//+------------------------------------------------------------------+
//|                                        JCC - 1 Trade on Open.mq4 |
//|                                         Juan Carlos Christensen. |
//|                                     http://www.eumefinancial.com |
//+------------------------------------------------------------------+
#property copyright "Juan Carlos Christensen."
#property link      "http://www.eumefinancial.com"

extern int MagicNumber           = 4635629;
extern double Lots               = 0.1;
extern int OpenHour              = 9;
extern int CloseHour             = 18;
extern int Slippage              = 3;
extern int Stoploss              = 20;
extern int Takeprofit            = 160;
extern int TrailingStop          = 0;
extern bool Use_MM               = True;
extern double MaximumRisk        = 0.2;
extern double DecreaseFactor     = 19;
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  int Operation, Ticket, Random, LastOp, cnt, total;
  double Price, StoplossPrice, TakeprofitPrice;
//----

   total=OrdersTotal();
   
   if(Hour()==OpenHour && total < 1)
   {
   
      MathSrand(TimeLocal());
   
      Random = MathRand();
   
      if(Random>=16384)
      {
         Operation = OP_BUY;
         Price = Ask;
         StoplossPrice = Price - Stoploss * Point;
         TakeprofitPrice = Price + Takeprofit * Point;
      }
      else if(Random<16384)
      {
         Operation=OP_SELL;
         Price = Bid;
         StoplossPrice = Price + Stoploss * Point;
         TakeprofitPrice = Price - Takeprofit * Point;
      }
   
      LastOp = Operation;
      if(Use_MM) Ticket = OrderSend(Symbol(), Operation, LotsOptimized(), Price, Slippage, StoplossPrice, TakeprofitPrice, NULL, MagicNumber, 0, Green);
      if(!Use_MM) Ticket = OrderSend(Symbol(), Operation, Lots, Price, Slippage, StoplossPrice, TakeprofitPrice, NULL, MagicNumber, 0, Green);
      
      if(Ticket<0)
      {
         Print("OrderSend failed with error #", GetLastError());
      }
   }

if(Ticket>0)
{
   if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
}

   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   
   //if(Hour()==CloseHour)
   //{
   //   OrderClose(OrderTicket(), Lots, Price, Slippage, Red);
   //   IsOnTrade = False;
   //}
//----
   return(0);
  }
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
  }